"""Takeaway game.

    >>> can_win(1)
    False

    >>> can_win(2)
    True

    >>> can_win(3)
    True

    >>> can_win(4)
    True

    >>> can_win(5)
    True

    >>> can_win(6)
    True

    >>> can_win(7)
    False

    >>> can_win(8)
    False

    >>> can_win(9)
    True

    >>> can_win(10)
    True
"""


def can_win(n):
    """Can this player win takeaway?"""

    # START SOLUTION

    # If this player cannot move, opponent wins
    if n < 2:
        return False

    # Try all of the legal moves
    for move in [2, 3, 5]:

        # If opp can't win if we made this move, we win
        if not can_win(n - move):
            return True

    # None of our moves kept opp from winning, so we lose
    return False


# cache of {nstones: can-we-win, ...}
cache = {}


def can_win_dynamic(n):
    """Can this player win takeaway?"""

    if n in cache:
        return cache[n]

    # If this player cannot move, opponent wins
    if n < 2:
        return False

    # Try all of the legal moves
    for move in [2, 3, 5]:
        they_could_win = can_win_dynamic(n - move)

        # If opp can't win if we made this move, we win
        if not they_could_win:
            cache[n] = True
            return True

    # None of our moves kept opp from winning, so we lose
    cache[n] = False
    return False


# END SOLUTION

if __name__ == '__main__':
    import doctest

    if doctest.testmod().failed == 0:
        print("\n*** ALL TESTS PASSED; NICE JOB!\n")
